<?php
if ( ! defined( 'ABSPATH' ) ) {
	die( 'Invalid request.' );
}

register_activation_hook( "massejli-wa/massejli_wa.php", 'msjli_on_activation' );
register_uninstall_hook("massejli-wa/massejli_wa.php", 'msjli_on_uninstall' );

function msjli_on_activation() {

    if ( ! current_user_can( 'activate_plugins' ) )
        return;
    $plugin = isset( $_REQUEST['plugin'] ) ? $_REQUEST['plugin'] : '';
    check_admin_referer( "activate-plugin_{$plugin}" );

    # insert Default values
    update_option( 'msjli_massejli_chats_with_us', msjli_massejli_chats_with_us );
    update_option( 'msjli_massejli_live_chat', msjli_massejli_live_chat );
    update_option( 'msjli_massejli_support_agent', msjli_massejli_support_agent );
    update_option( 'msjli_massejli_how_ican_help_you', msjli_massejli_how_ican_help_you );
    update_option( 'msjli_massejli_widget_send', msjli_massejli_widget_send );
    update_option( 'msjli_massejli_widget_close', msjli_massejli_widget_close );
    update_option( 'msjli_widget_type_message', msjli_widget_type_message );
    update_option( 'msjli_widget_write_your_message_first', msjli_widget_write_your_message_first );
    update_option( 'msjli_widget_location', "msjli_widget_location_right" );
    update_option( 'msjli_widget_location_right', "checked" );
    update_option( 'msjli_widget_location_left', "" );
    update_option( 'msjli_groups_send_groups', "checked" );
    update_option( 'msjli_groups_send_picture', "checked" );
    update_option( 'msjli_groups_send_video', "checked" );
    update_option( 'msjli_groups_send_title', "checked" );
    update_option( 'msjli_groups_send_message_length', "500" );
    update_option( 'msjli_user_send_private', "checked" );
    update_option( 'msjli_user_send_picture', "checked" );
    update_option( 'msjli_user_send_video', "checked" );
    update_option( 'msjli_user_send_title', "checked" );
    update_option( 'msjli_user_send_title', "checked" );
    update_option( 'msjli_user_send_message_length', "500" );
    update_option( 'msjli_groups_with_template', "checked" );
    update_option( 'msjli_user_with_template', "checked" );
    update_option( 'msjli_user_with_template', "checked" );
    update_option( 'msjli_widget_show_widget', "checked" );

    $site_title = get_bloginfo( 'name' );
    $site_url = network_site_url( '/' );
    $site_description = get_bloginfo( 'description' );

    $billing_phone =  get_user_meta( get_current_user_id(), 'billing_phone', true );
    $wa_link = "";
    if($billing_phone){
        $billing_phone = str_replace("+","",(int)$billing_phone);
        $wa_link = "https://wa.me/".$billing_phone;
    }

    $current_user = wp_get_current_user();

    $info = array(
                    "site_title" => $site_title,
                    "site_url" => $site_url,
                    "site_description" => $site_description,
                    "language" => get_bloginfo("language"),
                    "user_firstname" => $current_user->user_firstname,
                    "user_lastname" => $current_user->user_lastname,
                    "user_login" => $current_user->user_login,
                    "user_email" => $current_user->user_email,
                    "author_posts_url" => get_author_posts_url( get_current_user_id() ),
                    "billing_phone" => $billing_phone,
                    "wa_link" => $wa_link
                    );

    #file_put_contents( dirname( __FILE__ )."/act.txt", json_encode($info ) );

    # send register request
    if(!empty($info)){
        $ch = curl_init();
        curl_setopt( $ch, CURLOPT_USERAGENT, "massejli" );
        curl_setopt($ch, CURLOPT_URL,"https://my.massejli.com/Programs/wp-plugin/register.php");
        curl_setopt($ch, CURLOPT_POST, 1);
        curl_setopt($ch, CURLOPT_POSTFIELDS,json_encode($info));
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        $server_output = curl_exec($ch);
        curl_close ($ch);
        #$responce_arr = json_decode($server_output,true);
    }

}

function msjli_on_uninstall() {

    if ( ! current_user_can( 'activate_plugins' ) )
        return;

    $options_arr = array('msjli_wa_country','msjli_commands','msjli_token','msjli_service_number','msjli_bbs_key','msjli_nickname',
    'msjli_groups_send_groups','msjli_groups_send_picture','msjli_groups_send_video',
    'msjli_groups_send_part','msjli_groups_send_full_part','msjli_groups_send_title',
    'msjli_groups_send_specific_part','msjli_groups_send_message_length','msjli_user_send_private',
    'msjli_user_send_picture','msjli_user_send_video','msjli_user_send_part','msjli_user_send_full_part',
    'msjli_user_send_title','msjli_user_send_specific_part','msjli_user_send_message_length',
    'msjli_list_numbers','msjli_groups_with_template','msjli_user_with_template','msjli_cf7_check',
    'msjli_cf7_list_numbers','msjli_woocommerce_check','msjli_woocommerce_list_numbers');

    foreach($options_arr as $option){
        update_option( $option, "" );
    }

}
?>
