<?php
if ( ! defined( 'ABSPATH' ) ) {
	die( 'Invalid request.' );
}

add_action('wpcf7_before_send_mail', 'msjli_cf7form_detail');

function msjli_cf7form_detail($contact_form){
    global $post;
    if(get_option('msjli_cf7_check') == 'true'){
        $msjli_service_number = get_option( 'msjli_service_number' );
        $msjli_bbs_key = get_option( 'msjli_bbs_key' );
        $msjli_nickname = get_option( 'msjli_nickname' );
        //$msjli_contactform7_with_template = get_option( 'msjli_contactform7_with_template' );

        $msjli_cf7_list_numbers = str_replace("\r",'', get_option( 'msjli_cf7_list_numbers' )); // sometimes textarea use \r\n for newlines
        $msjli_cf7_list_numbers = validate_list_numbers($msjli_cf7_list_numbers);
        $skip_fields = ['g-recaptcha-response','_wpcf7','_wpcf7_version', '_wpcf7_locale', '_wpcf7_unit_tag', '_wpcf7_container_post'];
        $data = [];
        $submission = \WPCF7_Submission::get_instance();
        // getting all the fields or data from the form.
        $posted_data = $submission->get_posted_data();

        $message = "";
        $mobile_link = "";
        foreach ( $posted_data as $key => $value){

            if(in_array( $key, $skip_fields)){
                // unset will destroy the skip's fields.
                unset($posted_data[$key]);
            }
            else if(gettype($value) === 'array' ){

                //$posted_data[$key] = implode(', ',$value);
                $message .= "\n *".trim($key ). "*:  \n".implode(', ',$value)." \n";
            }
            else{
                $message .= "\n *". trim($key) . "*:  \n".$value." \n";
                if($key=="massejli-mobile"){$mobile_link = "wa.me/".$value;};
            }
        }
        //$fields = $posted_data;
        //file_put_contents(dirname( __FILE__ )."/fields.txt",json_encode($fields));
        $message .= "\n\n".$mobile_link ."\n\npowered by:\n massejli.com";
        //$permalink = bloginfo('wpurl');

        $post_date = date('Y-m-d H:i:s');


        $message_data =
            array(
                "op"=> "publish_message",
                "bbs" => $msjli_bbs_key,
                "nickname"=> $msjli_nickname,
                "data"=> array(
                            "link" => "",
                            "category" => "",
                            "title" => msjli_contact_form7_info_title,
                            "message" => $message,
                            "photo" => "",
                            "video" => "",
                            "audio" => "",
                            "document" => "",
                            "youtube" => "",
                            "list" => $msjli_cf7_list_numbers,// we will use only list of numbers , not all contact list
                            "service_numbers" => $msjli_service_number,
                            "send_to_groups" => false,
                            "send_to_contacts" => false,
                            "use_template" => false,
                            "message_gmt_date_time" => $post_date ,
                            "message_date_time" => "",
                            "wa_options" =>array("groups"=>array("type"=> "2","length"=>""),"private"=>array("type"=>"2","length"=>"")),
                            "private" => array("type"=> "2","length"=>"")),
            );
        #file_put_contents(dirname( __FILE__ )."/msjli_cf7_check.txt",json_encode($message_data));
        msjli_contactform_to_whatsapp($message_data,$msjli_bbs_key);

    }
}

?>
