<?php
if ( ! defined( 'ABSPATH' ) ) {
	die( 'Invalid request.' );
}

// Define a constant to use with html emails

function send_email_woocommerce_style($email, $subject, $heading, $message) {



	// @email - Email address of the reciever
	// @subject - Subject of the email
	// @heading - Heading to place inside of the woocommerce template
	// @message - Body content (can be HTML)
  	// Get woocommerce mailer from instance

  define("HTML_EMAIL_HEADERS", array('Content-Type: text/html; charset=UTF-8'));

  $mailer = WC()->mailer();

  // Wrap message using woocommerce html email template
  $wrapped_message = $mailer->wrap_message($heading, $message);

  // Create new WC_Email instance
  $wc_email = new WC_Email;

  // Style the wrapped message with woocommerce inline styles
  $html_message = $wc_email->style_inline($wrapped_message);

  // Send the email using wordpress mail function
  $mailer->send( $email, $subject, $html_message, HTML_EMAIL_HEADERS );

}


function msjli_posts_css_js(){
    echo '<link rel="stylesheet" href="https://pro.fontawesome.com/releases/v5.10.0/css/all.css" integrity="sha384-AYmEC3Yw5cVb3ZcuHtOA93w35dYTsvhLPVnYs9eStHfGJvOvKxVfELGroGkvsg+p" crossorigin="anonymous"/>';
    echo '<link rel="stylesheet" href="'.plugins_url( '/massejli-wa/styles/msjli_style.css' ).'">';
    echo '<script src="'.plugins_url( '/massejli-wa/js/msjli_scripts.js' ).'"></script>';

}

function validate_list_numbers($list){ # seperated by \n new line
    $valid_list = "";
    $phones = explode("\n",$list);
    foreach($phones as $number){
        if(valid_phone_number($number)){
            $valid_list .= $number ."\n";
        }
    }
    return $valid_list;
}

function valid_phone_number($phone_number){

    $phone_number = str_replace("+","",(int)$phone_number); # remove + and 00 from the phone prefix
    if(preg_match('/^[0-9]{9}+$/', $phone_number)){ # must be 10 numbers and more
        return false;
    }
    $string = file_get_contents(dirname( __FILE__ )."/dialing_code.json");
    $dialing_code = json_decode($string, true);
    if ($dialing_code) {
        foreach ($dialing_code as $country => $code) {
            if( substr($phone_number, 0, strlen($code)) == $code){
                //echo $country.$code;
                return true;
            }
        }
    }
    return false;
}

function msjli_contactform_to_whatsapp($message_data,$msjli_bbs_key){

    $responce_arr = array();

    //file_put_contents(dirname( __FILE__ )."/mm.txt",json_encode($message_data )." \n",FILE_APPEND );
		if(!empty($msjli_bbs_key))
		{
			$ch = curl_init();
            curl_setopt( $ch, CURLOPT_USERAGENT, "massejli" );
			curl_setopt($ch, CURLOPT_URL,"https://my.massejli.com/Programs/massejli/ajax/ajax_api.php");
			curl_setopt($ch, CURLOPT_POST, 1);
			curl_setopt($ch, CURLOPT_POSTFIELDS,json_encode($message_data));
			curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
			$server_output = curl_exec($ch);
			curl_close ($ch);
			$responce_arr = json_decode($server_output,true);
		}
        //file_put_contents(dirname( __FILE__ )."/m.txt",$server_output ." \n",FILE_APPEND );
        if(isset($responce_arr["status"])){

            if( $responce_arr["status"] == 1){

            }
            else{

            }

        }
}

function msjli_my_menu_pages(){
    #add_menu_page('Massejli WA Posts', 'Massejli WA Posts', 'manage_options', 'share-post', 'my_menu_output','dashicons-yes-alt' );
    add_menu_page(msjli_massejli_wa, msjli_massejli_wa, 'manage_options', 'massejli-wa', 'msjli_my_menu_output',plugins_url( 'massejli-wa/assets/icon.svg' ),20 );
}

function msjli_my_menu_output()
{
	require plugin_dir_path( __FILE__ ) . './msjli_options.php';
}

function general_admin_notice($post){
    global $post,$pagenow;
		$ptype = $post->post_type;

		$nickName = get_option( 'msjli_nickname' );
		$bbsKey = get_option( 'msjli_bbs_key' );
		$serviceNumber = get_option( 'msjli_service_number' );//Put here the service number which has been registered with massejli

		if ( $pagenow == 'edit.php'){
			$wa_status = get_service_number_status($nickName, $bbsKey, $serviceNumber);
			if($wa_status != 'green'){
				echo '<div class="notice notice-warning is-dismissible">
								 <p> ⚠️ <a href="https://my.massejli.com/Prog-massejli_section-whatsapp_ss-servicenumbers.pt">'
								 .msjli_check_my_massejli_wa_number_status.'.</a></p>
						 </div>';
			}

		}


    if ( $pagenow == 'post.php' and $ptype != 'shop_order' and $ptype != 'product'){
    //$meta_value = get_post_meta( $post->ID, 'custom_test',true);
    $is_sent = get_post_meta( $post->ID, 'is_sent',true);

        if( $is_sent ) {
            echo '<div class="notice notice-warning is-dismissible">
                     <p> ✅ '.msjli_was_sent_to_whatsapp.'.</p>
                 </div>';
        }
        else{
            echo '<div class="notice notice-error  is-dismissible">
                     <p> ❌ '.msjli_not_sent_whatsapp.'.</p>
                 </div>';

        }
    }
}

function msjli_wa_settings_link($links) {
  $settings_link = '<a href="admin.php?page=massejli-wa">'.msjli_settings.'</a>';
  array_unshift($links, $settings_link);
  return $links;
}

function msjli_add_custom_meta_box() {

	$args = array(
       'public'   => true,
       '_builtin' => true,
    );

    $output = 'names'; // names or objects, note names is the default
    $operator = 'and'; // 'and' or 'or'
    $post_types = get_post_types( $args, $output, $operator );

    foreach ( $post_types  as $post_type ) {
    	if($post_type !== 'attachment')
    	{
    		add_meta_box(
		       'custom_meta_box-2',       // $id
		       '<i class="fa-brands fa-whatsapp fa-1x" ></i> '.msjli_whatsapp_option, // $title
		       'msjli_show_custom_meta_box',  // $callback
		       $post_type,                 // $page
		       'normal',                  // $context
		       'high'                     // $priority
   			);
    	}
    }
}

function msjli_show_custom_meta_box() {
    global $post;

    // Use nonce for verification to secure data sending
    wp_nonce_field( 'massejli-wa', 'wpse_our_nonce' );
    $is_sent = get_post_meta( $post->ID, 'is_sent',true);
    ?>
    <input type="checkbox" id="send_post" name="send_post" value="true" >
  	<label for="send_post"><?php echo msjli_send_post; ?></label>
    <br/><br/>
    <a href="admin.php?page=massejli-wa" target="_blank"><?php echo msjli_change_settings; ?></a>
    <?php
}


function msjli_send_message_to_whatsapp($message_data,$post_id,$msjli_bbs_key){

    update_post_meta( $post_id, 'is_sent', false );
  	//simply we have to save the data now
  	//global $wpdb;
    $responce_arr = array();
    $wpse_value = $_POST['send_post'];

    #file_put_contents(dirname( __FILE__ )."/mm.txt",json_encode($message_data )." \n");

	if($wpse_value && $wpse_value == "true" )
	{
		if(!empty($msjli_bbs_key))
		{
			$ch = curl_init();
            curl_setopt( $ch, CURLOPT_USERAGENT, "massejli" );
			curl_setopt($ch, CURLOPT_URL,"https://my.massejli.com/Programs/massejli/ajax/ajax_api.php");
			curl_setopt($ch, CURLOPT_POST, 1);
			curl_setopt($ch, CURLOPT_POSTFIELDS,json_encode($message_data));
			curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
			$server_output = curl_exec($ch);
			curl_close ($ch);
			$responce_arr = json_decode($server_output,true);
		}
        #file_put_contents(dirname( __FILE__ )."/m.txt",$server_output ." \n");
        if(isset($responce_arr["status"])){

            if( $responce_arr["status"] == 1){

                update_post_meta( $post_id, 'is_sent', true );
            }
            else{
                update_post_meta( $post_id, 'is_sent', false );
            }

        }

	}

}

function text_truncate($string, $your_desired_width) {
  $parts = preg_split('/([\s\n\r]+)/', $string, null, PREG_SPLIT_DELIM_CAPTURE);
  $parts_count = count($parts);

  $length = 0;
  $last_part = 0;
  for (; $last_part < $parts_count; ++$last_part) {
    $length += strlen($parts[$last_part]);
    if ($length > $your_desired_width) { break; }
  }

  return implode(array_slice($parts, 0, $last_part));
}


function theme_oembed_videos() {

    global $post;

    if ( $post && $post->post_content ) {

        global $shortcode_tags;
        // Make a copy of global shortcode tags - we'll temporarily overwrite it.
        $theme_shortcode_tags = $shortcode_tags;

        // The shortcodes we're interested in.
        $shortcode_tags = array(
            'video' => $theme_shortcode_tags['video'],
            'embed' => $theme_shortcode_tags['embed']
        );
        // Get the absurd shortcode regexp.
        $video_regex = '#' . get_shortcode_regex() . '#i';

        // Restore global shortcode tags.
        $shortcode_tags = $theme_shortcode_tags;

        $pattern_array = array( $video_regex );

        // Get the patterns from the embed object.
        if ( ! function_exists( '_wp_oembed_get_object' ) ) {
            include ABSPATH . WPINC . '/class-oembed.php';
        }
        $oembed = _wp_oembed_get_object();
        $pattern_array = array_merge( $pattern_array, array_keys( $oembed->providers ) );

        // Or all the patterns together.
        $pattern = '#(' . array_reduce( $pattern_array, function ( $carry, $item ) {
            if ( strpos( $item, '#' ) === 0 ) {
                // Assuming '#...#i' regexps.
                $item = substr( $item, 1, -2 );
            } else {
                // Assuming glob patterns.
                $item = str_replace( '*', '(.+)', $item );
            }
            return $carry ? $carry . ')|('  . $item : $item;
        } ) . ')#is';

        // Simplistic parse of content line by line.
        $lines = explode( "\n", $post->post_content );
        foreach ( $lines as $line ) {
            $line = trim( $line );
            if ( preg_match( $pattern, $line, $matches ) ) {
                if ( strpos( $matches[0], '[' ) === 0 ) {
                    $ret = do_shortcode( $matches[0] );
                } else {
                    $ret = wp_oembed_get( $matches[0] );
                }
                return $ret;
            }
        }
    }
}


function msjli_send_wa_msg($contact,$title,$message){

		$nickName = get_option( 'msjli_nickname' );//Put yur nickname here, you will found it within authentication part in massejli panel
		$bbsKey = get_option( 'msjli_bbs_key' );//Put yur bbs key here, you will found it within authentication part in massejli panel
		$contactsList = $contact;//Put here list of phone numbers that you want to receive a message, separated by \n
		$serviceNumber = get_option( 'msjli_service_number' );//Put here the service number which has been registered with massejli

		//$title = msjli_login_send_title;
		//$message = "msjli_login_send_message \n";
		$link = "";//The url that you want to send,Optional
		$photoUrl = "";//The photo url that you want to send,Optional
		$videoUrl = "";//The video url that you want to send,Optional
		$audioUrl = "";//The audio url that you want to send,Optional
		$documentUrl = "";//The document url that you want to send,Optional
		$youtubeId = "";//The youtube id that you want to send,Optional
		$gmtDateTime = gmdate('Y-m-d H:i:s');//The gmt date time that the server will send this message, deleting this line or setting it to an empty value will let message to be sent now
		$messageDateTime = "";//The date that will be sent within message, Optional
		$sendToGroups = false;//Will this message be sent to your groups ?Optional
		$sendToContacts = false;//Will this message be sent to your contacts ?
		$useTemplate = false;//Will this message be wrapped within your massejli template,template can be set from your massejli panel
		$withCaption = true;//Set title and message as caption for any sent media, if you want to send the media in a separate message than the title and the message remove this line or set it to false
		$groupMessageType = "2";//The type of the sent message to groups,"0" => just title,"1" => specific length of the message,"2" => Full message
		$groupMessageLength = "";//The count of characters that we want to cut this message beyond it when sent to groups, it has no effect if groupMessageType is "0" or "1"
		$privateMessageType = "2";//The type of the sent message to contacts privately,"0" => just title,"1" => specific length of the message,"2" => Full message
		$privateMessageLength = "";//The count of characters that we want to cut this message beyond it when sent to contacts, it has no effect if groupMessageType is "0" or "1"

		$data = array();
		$data['op'] = 'publish_message';
		$data['bbs'] = $bbsKey;
		$data['nickname'] = $nickName;
		$data['data'] = array();

		$data['data']['link'] = $link;
		$data['data']['category'] = '';
		$data['data']['title'] = $title;
		$data['data']['message'] = $message;
		$data['data']['photo'] = $photoUrl;
		$data['data']['video'] = $videoUrl;
		$data['data']['audio'] = $audioUrl;
		$data['data']['document'] = $documentUrl;
		$data['data']['youtube'] = $youtubeId;
		$data['data']['list'] = $contactsList;
		$data['data']['service_numbers'] = $serviceNumber;
		$data['data']['send_to_groups'] = $sendToGroups;
		$data['data']['send_to_contacts'] = $sendToContacts;
		$data['data']['with_caption'] = $withCaption;
		$data['data']['use_template'] = $useTemplate;
		$data['data']['message_gmt_date_time'] = $gmtDateTime;
		$data['data']['message_date_time'] = $messageDateTime;
		$data['data']['wa_options'] = array(
				'groups' => array('type' => $groupMessageType,'length' => $groupMessageLength),
				'private' => array('type' => $privateMessageType,'length' => $privateMessageLength)
				);
		$data['data']['private'] = array('type' => $privateMessageType,'length' => $privateMessageLength);
		$time_sent = gmdate('H:i:s');
		$data_sent = msjli_make_request($data);

}

function msjli_make_request($fields){

      $curl = curl_init();
      $opts_arr = array(
          CURLOPT_URL => 'https://my.massejli.com/Programs/massejli/ajax/ajax_api.php',
          CURLOPT_RETURNTRANSFER => true,
          CURLOPT_ENCODING => "",
          CURLOPT_MAXREDIRS => 10,
          CURLOPT_TIMEOUT => 30,
          CURLOPT_SSL_VERIFYPEER => false,
          CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
          CURLOPT_CUSTOMREQUEST => 'POST',
          CURLOPT_USERAGENT => 'massejli'
          );

      $opts_arr[CURLOPT_POSTFIELDS] = http_build_query($fields);
      $opts_arr[CURLOPT_POST] = count($fields,COUNT_RECURSIVE);

      curl_setopt_array($curl, $opts_arr);
      $response = curl_exec($curl);
      $err = curl_error($curl);
      curl_close($curl);

      $temp = json_decode($response,true);
      if(!is_null($temp))
          $response = $temp;
      else
          $response = false;

      return $response;
}

function msjli_get_user_by_phone($billing_phone){
    global $wpdb;

    $user = $wpdb->get_row(
            "SELECT * FROM ".$wpdb->prefix."users as user
                LEFT JOIN ".$wpdb->prefix."usermeta as meta on meta.user_id = user.id
                WHERE meta.meta_key = 'billing_phone' AND meta.meta_value = $billing_phone;"
							);

    return $user;
}

function msjli_get_contact_wa_cred($id){
    global $wpdb;
    $user = $wpdb->get_row("SELECT * FROM `".$wpdb->prefix."msjli_cred`  WHERE `user_id` = $id ;");
    return $user;
}

function msjli_get_contact_wa_pass($user_name,$user_tkn){
    global $wpdb;
    $user = $wpdb->get_var("SELECT `user_pwd` FROM `".$wpdb->prefix."msjli_cred`  WHERE `user_name` = '$user_name' and `user_tkn` = '$user_tkn' ;");
    return $user;
}

function msjli_shortify($url){
    $postdata = http_build_query(array('url' => $url));

    $opts = array(
                    'http' => array('method'  => 'POST','header'  => 'Content-Type: application/x-www-form-urlencoded','content' => $postdata,'timeout' => 5),
                    "ssl"=>array("verify_peer"=>false,"verify_peer_name"=>false)
                );
    $context  = stream_context_create($opts);

    $shortned_url = @file_get_contents("https://msj.li/index.php?url=$url",false,$context);
    return $shortned_url?:$url;
}

function randomPassword($pass_len) {
    $alphabet = "abcdefghijklmnopqrstuwxyzABCDEFGHIJKLMNOPQRSTUWXYZ0123456789";
    $pass = array(); //remember to declare $pass as an array
    $alphaLength = strlen($alphabet) - 1; //put the length -1 in cache
    for ($i = 0; $i < $pass_len; $i++) {
        $n = rand(0, $alphaLength);
        $pass[] = $alphabet[$n];
    }
    return implode($pass); //turn the array into a string
}

function blind_pswrd($password){

	$word = strtolower($password) ^ strtoupper($password) ^ $password;
	$word = strrev(base64_encode($word));
	return $word;

}

function clear_pswrd($blind_pswrd){

	$word = base64_decode(strrev($blind_pswrd));
	$word = strtolower($word) ^ strtoupper($word) ^ $word;
	return $word;

}

function msjli_correct_wa_number($mobile_number){ // 036987123 -> 96136987123

	$msjli_wa_country = get_option( 'msjli_wa_country' );

	$mobile_number = str_replace("+","",ltrim($mobile_number, "0"));
	if(!empty($msjli_wa_country)){
		if( (substr($mobile_number, 0, strlen($msjli_wa_country)) != $msjli_wa_country) and strlen($mobile_number)<10 ){
				$mobile_number = $msjli_wa_country.$mobile_number;
		}
	}
	return $mobile_number;

}

function get_service_number_status($nickname,$bbs,$service_number)
    {
        $curl = curl_init();

        curl_setopt_array($curl, array(
          CURLOPT_URL => 'https://my.massejli.com/Programs/massejli/ajax/ajax_api.php',
          CURLOPT_RETURNTRANSFER => true,
          CURLOPT_ENCODING => '',
          CURLOPT_MAXREDIRS => 10,
          CURLOPT_TIMEOUT => 0,
          CURLOPT_FOLLOWLOCATION => true,
          CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
          CURLOPT_CUSTOMREQUEST => 'GET',
          CURLOPT_POSTFIELDS =>'{
            "op": "qrcode",
            "platform": "whatsapp",
            "nickname": "'.$nickname.'",
            "bbs": "'.$bbs.'",
            "servicenumber": "'.$service_number.'"
        }',
          CURLOPT_HTTPHEADER => array(
            'User-Agent: massejli',
            'Content-Type: application/json',
            'Cookie: phpTransformer=smods93hnsu9epo3o1pkie4e2f'
          ),
        ));

        $response = curl_exec($curl);

        curl_close($curl);
        $response_arr = json_decode($response,true);

        if($response_arr && isset($response_arr['status']) && $response_arr['status'] === '1')
            {return $response_arr['number_status'];}
        else
            {return "red";}
    }

function cleanBBcodes($text){
	global $shortcode_tags;
	foreach ($shortcode_tags as $shortcode) {
		$text = remove_shortcode('gallery', $text);
	}
	return $text;
}
?>
