<?php

if ( ! defined( 'ABSPATH' ) ) {
die( 'Invalid request.' );
}

function msjli_create_user( $user_id ){
	global $wpdb;
	if ( ! is_admin() ) {
			$password  = filter_var($_POST['account_password'], FILTER_SANITIZE_STRING);
			$password = blind_pswrd($password);
			$billing_phone  = filter_var($_POST['billing_phone'], FILTER_SANITIZE_STRING);
			$billing_phone = msjli_correct_wa_number($billing_phone);

			$user = get_user_by( 'id', $user_id );
			$user_login = $user->user_login;

			update_user_meta( $user_id, 'billing_phone', $billing_phone );
			$token =  randomPassword(8);
			$table_msjli_cred  = $wpdb->prefix."msjli_cred";

			if(!empty($password )){
					$table_name = $wpdb->prefix . 'msjli_cred';
	 				$new_usr = $wpdb->query( " INSERT INTO $table_name(`user_id`, `user_name`, `user_phone`, `user_pwd`, `user_tkn`)
																			VALUES( $user_id ,'".$user_login."','$billing_phone','$password','$token' );" );

			}
	}
}

add_action('user_register','msjli_create_user' );

function msjli_wp_login() {

	//register or send link if customer exist, this will be sent from login.php to get login info or register new one
	if(isset($_GET['msj_reg']) ){

			if(isset($_GET['msj_tkn'])){
				$msj_tkn = get_option( 'msjli_token' );
				if($msj_tkn != $_GET['msj_tkn']){
					die("invalid token");
				}
			}
			else{
				die("token not set");
			}

			$contact_mobile = preg_replace('/[^0-9]/', '', $_GET['msj_reg']);
			$contact_mobile = msjli_correct_wa_number($contact_mobile);
			if(strlen($contact_mobile) > 9 ) { // Valid mobile number
				$user = msjli_get_user_by_phone($contact_mobile);
				if (!empty($user)) {
					// user exist
					$cred_info = msjli_get_contact_wa_cred($user->ID);
					if(!empty($cred_info)){
							$link = get_bloginfo('url')."/?log=".$cred_info->user_name."&tkn=".$cred_info->user_tkn;
							$message = str_replace( "PHP_EOL" , "\n" , msjli_login_send_message);
							$message = $message ."\n\n🔗".msjli_shortify($link);
							msjli_send_wa_msg($contact_mobile,msjli_login_send_title,$message);
					}
					else{
						// this user dont have info into wp_msjli_cred table
					}
				}
				else{
					//upadte WP user
					$pass = randomPassword(24);
					$new_user_id = wp_create_user($contact_mobile, $pass, $contact_mobile.'@'.$_SERVER['SERVER_NAME']);
					if ( is_wp_error( $new_user_id ) ) {
							// USER EXIST BUT billing_phone not the same for WA
							$user = get_user_by('login',$contact_mobile);
							if($user){
								 update_user_meta( $user->ID, 'billing_phone', $contact_mobile );
							}
					}
					else{
						// WP user was  created
						update_user_meta( $new_user_id, 'billing_phone', $contact_mobile );
						$account_url = $_SERVER['SERVER_NAME']."/my-account/";
						$message = msjli_login_create_user . "\n\n" .msjli_user_name .":\n"
											.$contact_mobile ."\n\n".msjli_user_pass.":\n". $pass."\n\n"
											.msjli_account_url."\n". $account_url;
						msjli_send_wa_msg($contact_mobile,msjli_create_user_title,$message);

					}
					//insert info for massejli
					 global $wpdb;
	 			   $table_name = $wpdb->prefix . 'msjli_cred';
					 $token =  randomPassword(8);
					 $b_pass = blind_pswrd($pass);
	 				 $in_usr = $wpdb->query( "INSERT INTO $table_name(`user_id`, `user_name`, `user_phone`, `user_pwd`, `user_tkn`)
					 								VALUES( '$new_user_id' ,'$contact_mobile','$contact_mobile','$b_pass','$token' );" );

					// send credentials AND link by WA message
					$link = get_bloginfo('url')."/?log=".$contact_mobile."&tkn=".$token;
					$message = str_replace( "PHP_EOL" , "\n" , msjli_login_send_message);
					$message = $message ."\n\n🔗".msjli_shortify($link);
					msjli_send_wa_msg($contact_mobile,msjli_login_send_title,$message);

				}
			}
		}

		if(isset($_GET['log']) and isset($_GET['tkn'])){ //DO User Login

			// Change token and login user
			$user_name  = filter_var($_GET['log'], FILTER_SANITIZE_STRING);
			$user_tkn  = filter_var($_GET['tkn'], FILTER_SANITIZE_STRING);
			if (!empty($user_name)) {
				//do login for this user
				$b_pass = msjli_get_contact_wa_pass($user_name,$user_tkn);
				$pass = clear_pswrd($b_pass) ;
				$creds = array();
				$creds['user_login'] = $user_name;
				$creds['user_password'] = $pass;
				$creds['remember'] = true; //Do you want the log-in details to be remembered?
				//change token
				global $wpdb;
				$new_token =  randomPassword(8);
		    	$table_msjli_cred  = $wpdb->prefix."msjli_cred";
		    	$wpdb->query(
								"UPDATE $table_msjli_cred
		                SET `user_tkn` = '$new_token'
		             		WHERE `user_name` = '$user_name' ;");

				//Try logging in
				$user = wp_signon( $creds, false );
				$checkout_url = wc_get_checkout_url();
            	$shop_page_url = get_permalink( wc_get_page_id( 'shop' ) );
				if ( !is_wp_error($user) ) {
					$userID = $user->ID;
					wp_set_auth_cookie( $userID, true, false );
					wp_set_current_user( $user );

                	if ( WC()->cart->get_cart_contents_count() == 0 ) {
						$redirect_url = $shop_page_url;
					}
                	else{
                		$redirect_url = $checkout_url ;
                	}
                    wp_safe_redirect($redirect_url);
					exit;
				}
				else{

					wp_safe_redirect($shop_page_url);
					exit;
				}
			}
			else {
				//user not found maybe attack
				wp_safe_redirect("index.php");
				exit;
			}
	}
}

function msj_wa_checkout_header(){
	global $wp;
    $request = explode( '/', $wp->request );

	if ( !is_user_logged_in() ) {
			$msjli_service_number = get_option( 'msjli_service_number' );
			$msjli_commands = get_option( 'msjli_commands' );
		echo '<link rel="stylesheet" href="'.plugins_url( '/massejli-wa/styles/msjli_woo.css' ).'">';
		echo "<h6>".msjli_youcan_login_from_wa.":</h6>";
		echo "<div class='msjli_wa_div' >
						<a href='https://wa.me/$msjli_service_number?text=$msjli_commands'>".msjli_login_by_wa."</a>
						<img  src='https://shilaziz.com/wp-content/plugins/massejli-wa//assets/icon-widget.png' class='msjli_wa_image'>
					</div><br/><br/>";

		echo msjli_or_login_by_user_name_and_password .":<br/>";

		if( ! ( end($request) == 'my-account' && is_account_page() ) ){

			echo '<div id="toogle_customer_details" class="msjli_key_div" onclick="toogle_customer_details();" >'.			msjli_create_user_traditional_account.'
					<img  src="https://shilaziz.com/wp-content/plugins/massejli-wa//assets/key.png" class="msjli_key_image">
							</div>';
			echo '<script src="'.plugins_url( '/massejli-wa/js/msjli_woo.js' ).'"></script>';
				}

	}
}
add_action("woocommerce_checkout_before_customer_details",'msj_wa_checkout_header');
add_action( 'woocommerce_login_form_start', 'msj_wa_checkout_header' );

//get password when user changeit
function msjli_profile_update( $user_id ) {
		global $wpdb;
    //if ( ! is_admin() ) {
				if(isset($_POST['pass1'])){
                	$password  = filter_var($_POST['pass1'], FILTER_SANITIZE_STRING);
                }
				else{
                	$password  = filter_var($_POST['password_1'], FILTER_SANITIZE_STRING);
                }

				$password = blind_pswrd($password);
				if(isset($_POST['billing_phone'])){
					$billing_phone  = filter_var($_POST['billing_phone'], FILTER_SANITIZE_STRING);
					$billing_phone = msjli_correct_wa_number($billing_phone);
					update_user_meta( $user_id, 'billing_phone', $billing_phone );
				}

				$uid = get_current_user_id();
				if (!empty($uid)) {
					$table_msjli_cred  = $wpdb->prefix."msjli_cred";
					if(!empty($password )){
						$wpdb->query(	"UPDATE $table_msjli_cred SET  `user_pwd` = '".$password."'
												WHERE `user_id` = '".$user_id."' ;");
					}
					if(!empty($billing_phone )){
						$wpdb->query(	"UPDATE $table_msjli_cred SET `user_phone` = '".$billing_phone."'
												WHERE `user_id` = '".$user_id."' ;");
					}
				}
    //}
}
add_action( 'profile_update', 'msjli_profile_update' );


function msjli_remove_user( $user_id ) {
		global $wpdb;
	   $user_meta = get_userdata( $user_id );
		 $del_usr = $wpdb->query( " DELETE FROM `".$wpdb->prefix."msjli_cred` WHERE `user_id` =  $user_id limit 1;" );

}
add_action( 'delete_user', 'msjli_remove_user', 10 );

?>
