<?php
if ( ! defined( 'ABSPATH' ) ) {
	die( 'Invalid request.' );
}

function msjli_publish_post( $post_id ) {

    global $post;

   	$send_arr = array();
  	// verify nonce
  	if (!isset($_POST['wpse_our_nonce']) || !wp_verify_nonce($_POST['wpse_our_nonce'], 'massejli-wa'))
      return 'nonce not verified';
    #file_put_contents(dirname( __FILE__ )."/msjli_publish_post.txt"," fired \n");
  	// check autosave
  	if ( wp_is_post_autosave( $post_id ) )
      return 'autosave';

  	//send status
  	$send_status = get_post_meta($post_id,"send_status",true);

  	//check post revision
  	if ( wp_is_post_revision( $post_id ) )
      return 'revision';

  	// check permissions
  	if ( 'post' == $_POST['post_type'] ) {
      if ( ! current_user_can( 'edit_page', $post_id ) )
          return 'cannot edit page';
      } elseif ( ! current_user_can( 'edit_post', $post_id ) ) {
          return 'cannot edit post';
  	}

    $post_date =  gmdate('Y-m-d H:i:s');
    $post_publish_date = get_the_time('Y-m-d H:i:s', $post->ID);

  	$title = get_the_title($post_id);
  	$link = urldecode(stripslashes(get_the_permalink($post_id)));
    $author = $post->post_author;
    $name = get_the_author_meta( 'display_name', $author );
    $email = get_the_author_meta( 'user_email', $author );
    $title = $post->post_title;
    $message = trim(strip_tags($post->post_content));
		$message = cleanBBcodes($message);
    $message = trim(preg_replace("/[\r\n]+/", "\n", $message));
    $photo_url = get_the_post_thumbnail_url($post->ID,'full');
    $permalink = urldecode(get_permalink($post->ID));

    $video_url = "";
    //Get the content, apply filters and execute shortcodes
    $content = apply_filters( 'the_content', $post->post_content );
    $embeds = get_media_embedded_in_content( $content );
    //The first item of the array is the first embedded media in the content
    $first_media = $embeds[0];
    $regex = '/https?\:\/\/[^\",]+/i';
    preg_match_all($regex, $first_media, $matches);
    if($matches){
        $video_url = $matches[0][0];
    }

    # check if this is a youtube
    $youtube_url = "";
    $youtube_regexp = '~
                      ^(?:https?://)?                           # Optional protocol
                       (?:www[.])?                              # Optional sub-domain
                       (?:youtube[.]com/watch[?]v=|youtu[.]be/) # Mandatory domain name (w/ query string in .com)
                       ([^&]{11})                               # Video id of 11 characters as capture group 1
                        ~x';
    preg_match($youtube_regexp, $video_url, $youtube_matches);

	// Remove empty values from the array (regexp shit).
	$array_matches = array_filter($youtube_matches, function($var) {
		return($var !== '');
	});
	// If we have 2 elements in array, it means we got a valid url!
	// $matches[2] is the youtube ID!
	if (sizeof($array_matches) == 2) {
		$youtube_url = $video_url;
        $video_url = "";
	}


	$msjli_service_number = get_option( 'msjli_service_number' );
	$msjli_bbs_key = get_option( 'msjli_bbs_key' );
	$msjli_nickname = get_option( 'msjli_nickname' );

	$msjli_groups_send_groups = get_option( 'msjli_groups_send_groups' );
    if($msjli_groups_send_groups == "checked"){
        $msjli_groups_send_groups = True;
        $msjli_groups_with_template = get_option( 'msjli_groups_with_template' );
        if($msjli_groups_with_template == "checked"){
            $msjli_groups_with_template = true;
        }else{
            $msjli_groups_with_template = false;
        }
        $msjli_groups_send_picture = get_option( 'msjli_groups_send_picture' );
        if($msjli_groups_send_picture != "checked"){
            $photo_url = "";
        }
        $msjli_groups_send_video = get_option( 'msjli_groups_send_video' );
        if($msjli_groups_send_video != "checked"){
            $youtube_url = "";
            $video_url = "";
        }

        $msjli_groups_send_part = get_option( 'msjli_groups_send_part' );
        #file_put_contents(dirname( __FILE__ )."/vv.txt",json_encode($msjli_groups_send_part )." \n");
        if( $msjli_groups_send_part == "msjli_groups_send_title" ){
            $message = "";
        }
        elseif($msjli_groups_send_part == "msjli_groups_send_specific_part" ){
            $msjli_groups_send_message_length = get_option( 'msjli_groups_send_message_length' );
            $message = text_truncate($message, $msjli_groups_send_message_length) ;
        }

        $groups_message_data =
            array(
                "op"=> "publish_message",
                "bbs" => $msjli_bbs_key,
                "nickname"=> $msjli_nickname,
                "data"=> array(
                            "link" => $permalink,
                            "category" => "",
                            "title" => $title,
                            "message" => $message ,
                            "photo" => $photo_url,
                            "video" => $video_url,
                            "audio" => "",
                            "document" => "",
                            "youtube" => $youtube_url,
                            "list" => "",
                            "service_numbers" => $msjli_service_number,
                            "send_to_groups" => true,
                            "send_to_contacts" => false, // we will use only list of numbers , not all contact list
                            "use_template" => $msjli_groups_with_template,
                            "message_gmt_date_time" => $post_date ,
                            "message_date_time" => $post_publish_date,
                            "wa_options" =>array("groups"=>array("type"=> "2","length"=>""),"private"=>array("type"=>"2","length"=>"")),
                            "private" => array("type"=> "2","length"=>"")),
            );

        msjli_send_message_to_whatsapp($groups_message_data,$post_id,$msjli_bbs_key);
    }


    $msjli_user_send_private = get_option( 'msjli_user_send_private' );
    if($msjli_user_send_private == "checked"){
        $msjli_list_numbers = str_replace("\r",'', get_option( 'msjli_list_numbers' )); // sometimes textarea use \r\n for newlines
        $msjli_list_numbers = validate_list_numbers($msjli_list_numbers);

        $msjli_user_with_template = get_option( 'msjli_user_with_template' );
        if($msjli_user_with_template == "checked"){
            $msjli_user_with_template = true;
        }else{
            $msjli_user_with_template = false;
        }
        $msjli_user_send_picture = get_option( 'msjli_user_send_picture' );
        if($msjli_user_send_picture != "checked"){
            $photo_url = "";
        }
        $msjli_user_send_video = get_option( 'msjli_user_send_video' );
        if($msjli_user_send_video != "checked"){
            $youtube_url = "";
            $video_url = "";
        }

        $msjli_user_send_part = get_option( 'msjli_user_send_part' );
        #file_put_contents(dirname( __FILE__ )."/vv.txt",json_encode($msjli_user_send_part )." \n");
        if( $msjli_user_send_part == "msjli_user_send_title" ){
            $message = "";
        }
        elseif($msjli_user_send_part == "msjli_user_send_specific_part" ){
            $msjli_user_send_message_length = get_option( 'msjli_user_send_message_length' );
            $message = text_truncate($message, $msjli_user_send_message_length) . " ... ";
        }

        $private_message_data =
            array(
                "op"=> "publish_message",
                "bbs" => $msjli_bbs_key,
                "nickname"=> $msjli_nickname,
                "data"=> array(
                            "link" => $permalink,
                            "category" => "",
                            "title" => $title,
                            "message" => $message ,
                            "photo" => $photo_url,
                            "video" => $video_url,
                            "audio" => "",
                            "document" => "",
                            "youtube" => $youtube_url,
                            "list" => $msjli_list_numbers,
                            "service_numbers" => $msjli_service_number,
                            "send_to_groups" => false,
                            "send_to_contacts" => false, // we will use only list of numbers , not all contact list
                            "use_template" => $msjli_user_with_template,
                            "message_gmt_date_time" => $post_date ,
                            "message_date_time" => "",
                            "wa_options" =>array("groups"=>array("type"=> "2","length"=>""),"private"=>array("type"=>"2","length"=>"")),
                            "private" => array("type"=> "2","length"=>"")),
            );

        msjli_send_message_to_whatsapp($private_message_data,$post_id,$msjli_bbs_key);

    }

}

?>
