<?php
if ( ! defined( 'ABSPATH' ) ) {
	die( 'Invalid request.' );
}

if(get_option( 'msjli_widget_show_widget' ) == "checked"){
    add_action( 'wp_enqueue_scripts', 'msjli_widget_styles_and_js');
    add_action('wp_footer', 'msjli_display_widget');
}

function msjli_display_widget() {
?>
    <input id="msjli-typing-text" type="hidden" value="<?php echo get_option( 'msjli_massejli_how_ican_help_you' ); ?>"/>

    <div class="msjli-open-button"  id="msjli-open-button">
        <a href="#close" class="msjli_exit_close" onclick="msjli_exit_close()" >x</a>
        <span onclick="msjli_open_form()" class="msjli-open-chat-text" ><?php echo get_option( 'msjli_massejli_chats_with_us' ); ?></span>
        <img onclick="msjli_open_form()" src="<?php echo plugin_dir_url( __FILE__ ); ?>/assets/icon-widget.png" class="msjli-wa-icon" />
    </div>

    <div class="msjli-chat-popup" id="msjli_widget_form">
      <form action="https://wa.me/<?php echo get_option( 'msjli_service_number' );  ?>" class="msjli-form-container">
        <div class="msjli-chat-header">
            <img src="<?php echo plugin_dir_url( __FILE__ ) ; ?>/assets/icon-widget.png"  />
            <span><?php echo get_option( 'msjli_massejli_live_chat' );  ?></span>
        <div>
        <div class="msjli-chat-agent" >

            <div class="msjli-chat-agent-name">
                <?php echo get_option( 'msjli_massejli_support_agent' );  ?>:
            </div>
            <span id="typing" ></span>
        </div>
        <div class="msjli-chat-customer" >
             <textarea class="msjli-textarea-customer" placeholder="<?php echo get_option( 'msjli_widget_type_message' );  ?>" name="text" required 
             oninvalid="this.setCustomValidity('<?php echo get_option( 'msjli_widget_write_your_message_first' );  ?>')"  ></textarea>
        </div>
        <button type="submit" class="msjli-btn">Send</button>
        <button type="button" class="msjli-btn msjli-cancel" onclick="msjli_close_form()"><?php echo get_option( 'msjli_massejli_widget_close' );  ?></button>
        <div class="msjli-footer">
            <a href="https://massejli.com" target="_blank">powered by massejli.com</a>
        </div>
      </form>
    </div>
<?php
}

function msjli_widget_styles_and_js() {
    if(get_option('msjli_widget_location_right') == "checked"){
        wp_enqueue_style( 'msjli_widget_style', plugin_dir_url( __FILE__ ).'/styles/msj_widget_style_right.css' , array());
    }
    else{
        wp_enqueue_style( 'msjli_widget_style', plugin_dir_url( __FILE__ ).'/styles/msj_widget_style_left.css' , array());
    }
    
    wp_enqueue_script( 'msjli_widget_js', plugin_dir_url( __FILE__ ).'/js/msjli_widget_scripts.js' , array(),false, true);
}

?>